//Titel:            Testbeispuiel fr MDI-Fenster
//Version:          1.0
//Copyright:        HS-Harz, FB AI
//Autor:            Dipl.-Inf.(TU) Dipl.-Ing.(FH) Michael Wilhelm
//Firma:
//Beschreibung:     Einfaches Beispiel


// Beispiel fr das Observer Design Pattern
// Mit der Eingabetaste wird der Inhalt aktualisiert

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


// InternalFrame
import javax.swing.event.*;

import java.util.Observable;
import java.util.Observer;


public class Pattern_MVC2 extends JFrame {

  // Container fr die Clientfenster
  private JDesktopPane _desktopPane = new JDesktopPane();

    // Men Variablen
  private JMenuBar menuBar1;
  private JMenu MainFile;
  private JMenuItem MnNew;
  private JMenuItem MnOpen;
  private JMenuItem MnClose;

  private JMenu MainEdit;
  private JMenuItem MnCut;
  private JMenuItem MnCopy;
  private JMenuItem MnInsert;

  private int _Fensternummer=0;


  // 3. schritt  Modell Variable deklarieren
  private CName name;   // Modell

   // Konstruktor
  public Pattern_MVC2() {
    this.setSize(new Dimension(800, 400));
    setGUI();
  }

  public void setGUI() {
    this.getContentPane().setLayout( new BorderLayout() );
    this.setContentPane(_desktopPane);

    setMenus();
    // Pattern_MVC
    // 4. schritt  Modell Variable erzeugen
    name = new CName();
    name.setName("Paul");
  }



    // setzt die Mens
  private void setMenus() {
    menuBar1 = new JMenuBar();

      // DATEI
    MainFile = new JMenu("Datei");
    MnNew = new JMenuItem("Neu");
    MnClose = new JMenuItem("Schlieen");

    MnNew.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        MnNew_actionPerformed(e);
      }
    });
    MnNew.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
    MainFile.add(MnNew);

    MainFile.addSeparator();

    // --------------------------
    MnClose.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnClose_actionPerformed(e);
      }
    });
    MainFile.add(MnClose);


    menuBar1.add(MainFile);

    // ----------------
    this.setJMenuBar(menuBar1);

  } // setMenus


  // Men Aktions Methoden

  void MnNew_actionPerformed(ActionEvent e) {
    JInternalFrame[] ff = _desktopPane.getAllFrames();
    int n=ff.length+1;
    _Fensternummer++;

    // 5. schritt  Viewer erzeugen
    JFInternalFrame1 frame =
         new JFInternalFrame1(
           Integer.toString(_Fensternummer), n%3, name);

    ff = _desktopPane.getAllFrames();
    int i = ff.length;
    int w = ff.length*260;
    int h = ff.length*110;
    frame.setBounds( 10, 10, 380, 50);
    frame.setLocation(  (i%2)*390+10, 60+110*(i/2)  );

    _desktopPane.add(frame, new Integer(1));
  }


  void MnClose_actionPerformed(ActionEvent e) {
    System.exit(0);
  }



  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }


  static public void main(String[] args) {
    try  {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
    }
    Pattern_MVC2 frame = new Pattern_MVC2();
    frame.setVisible(true);
  }

  void jTextField1_actionPerformed(ActionEvent e) {
         System.out.println("Return gedrckt");
  }



}  // Pattern_MVC1


//   |
//  +--java.util.Observable

// 1. Schritt ableiten von Observable
class CName  extends java.util.Observable {
  String sName= "Zappa";

  public String getName() {
    return sName;
  }

  public void setName(String Name) {
    this.sName = Name;
  }

    // Diese Methode wird von einem Viewern aufgerufen
    //
    // 2. Schritt  Methode fr Viewer
  public void DataChangedFromViewer(int nr, String s) {
    System.out.println("s in CName: "+s);
    this.setName(s);  // genderte Daten speichern
    super.setChanged();
      // Sende Nachricht an ALLE Viewer
    super.notifyObservers( new Integer(1) );
  }

} // CName


    // 6. schritt  nternalFrame
    // Implements einbauen
    // Methode Update
class JFInternalFrame1 extends JInternalFrame
                     implements Observer {
  private String _sFileName;

  private JLabel label1 = new JLabel("Student");
  private JTextField edit = new JTextField("XXXXX");

  private CName _DatenModell;
  private String _Caption;
  int nr;

  public JFInternalFrame1(
       String Caption, int nr,
       Observable DatenModell) {
    _Caption = Caption;   
    setTitle(Caption);
    this.nr=nr;

    _DatenModell = (CName) DatenModell;  //

    DatenModell.addObserver(this);  // registrierung

    setGUI();
  }

  public void setGUI() {
    CName name = (CName) _DatenModell;

    label1.setFont( new Font("Arial", Font.BOLD,28));
    edit.setText(  name.getName()     );
    edit.setFont( new Font("Arial", Font.BOLD,28));

    this.setClosable(true);
    this.setIconifiable(true);
    this.setMaximizable(true);
    this.setResizable(true);
    this.getContentPane().setLayout( new GridLayout(1,2) );


    this.getContentPane().add(label1);
    this.getContentPane().add(edit);

    edit.addActionListener(new java.awt.event.ActionListener() {
        //  Aufgerufen wenn Return-Taste
      public void actionPerformed(ActionEvent e) {
        edit_Change(e);
      }
    });


  }  // setGUI
  

    // 7. schritt  Update-Methode
    //   aufgerufen vom Controller !
  public void update(Observable o, Object arg) {
    System.out.println("Update");
    Integer I = (Integer) arg;
//    if ( ( I.intValue()==nr) || ( I.intValue()==0) ){
      System.out.println("ich bin gemeint: "+_Caption);
      edit.setText( _DatenModell.getName() );
      edit.updateUI();
  //  }
  }

    // 8. schritt  aufgerufen von der Return-Taste
  void edit_Change(ActionEvent e) {
    System.out.println("gendert");
    _DatenModell.DataChangedFromViewer( nr, new String(edit.getText()  ) );
  }



}  // JFInternalFrame1


